#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <iostream>
#include <fstream>
#include <string>
#include <vector>

////////////////////////////////////////////////////////////////////////////////

#define DEF_STR_VERSION         "0.1.0.0"

////////////////////////////////////////////////////////////////////////////////

using namespace std;

char*               me = NULL;
char                savefilename[256] = {0};
vector< string >    savecontents;

////////////////////////////////////////////////////////////////////////////////

bool loadSaveFile( const char* fn )
{
    ifstream savefile;

    savefile.open( fn );

    if ( savefile.is_open() == true )
    {
        while( savefile.eof() == false )
        {
            string aline;

            getline( savefile, aline );

            savecontents.push_back( aline );
        }
        savefile.close();

        return true;
    }
    return false;
}

bool writeSaveFile()
{
    ofstream savefile;

    savefile.open( savefilename );

    if ( savefile.is_open() == true )
    {
        for ( int cnt=0; cnt<savecontents.size(); cnt++ )
        {
            savefile << savecontents[cnt].c_str() << endl;
        }

        savefile.close();

        return true;
    }

    return false;
}

void printhelp()
{
    printf("\t usage : %s [save file (*.sav)]\n", me );
    printf("\n");
}

void makemestr( const char* s )
{
    if ( s != NULL )
    {
        char* dstr = strdup( s );
        char* stok = strtok( dstr, "\\" );
        while ( stok != NULL )
        {
            char* tmptok = NULL;

            if ( stok != NULL )
            {
                tmptok = strdup( stok );
            }

            stok = strtok( NULL, "\\" );

            if ( stok != NULL )
            {
                free( tmptok );
            }
            else
            {
                me = tmptok;
            }
        }
    }
}

bool makevaluemax( string &s )
{
    size_t cpos = s.find(": ");

    if ( cpos > 0 )
    {
        cpos += 2;

        string snum   = s.substr( cpos );
        size_t snumsz = snum.size();
        int    num    = atoi( snum.c_str() );

        if ( num < 190 )
        {
            s.replace( cpos, snumsz, "190" );

            return true;
        }
    }

    return false;
}

bool changevalues()
{
    if ( savecontents.size() > 0 )
    {
        int changedcnt = 0;

        for( int cnt=0; cnt<savecontents.size(); cnt++ )
        {
            string chkstr = savecontents[cnt];
            bool   foundb = false;

            if ( chkstr.find( "stamina:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "tu:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "throwing:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "health:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "firing:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "strength:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "psiStrength:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "bravery:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "reactions:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "melee:" ) != string::npos )
            {
                foundb = true;
            }
            else
            if ( chkstr.find( "psiSkill:" ) != string::npos )
            {
                foundb = true;
            }

            if ( foundb == true )
            {
               if ( makevaluemax( chkstr ) == true )
                {
                    savecontents[cnt] = chkstr;
                    changedcnt++;
                }
            }
        }

        if ( changedcnt > 0 )
            return true;
    }

    return false;
}

int main( int argc, char* argv[] )
{
    printf("openXcom save file modder for soldires, version %s\n", DEF_STR_VERSION );
    printf("(C)2016 raph.kay\n");
    printf("\n");

    makemestr( argv[0] );

#ifndef DEBUG
    if ( argc < 2 )
    {
        printhelp();
        return 0;
    }

    strcpy( savefilename, argv[1] );
#else
    strcpy( savefilename, "save03.sav" );
#endif

    printf( "Loading : %s ... ", savefilename );
    if ( loadSaveFile( savefilename ) == true )
    {
        printf( "Ok.\n" );
        printf( "Changing values ... ");

        if ( changevalues() == true )
        {
            printf( "Ok.\n" );

            char newfname[256] = {0};
            sprintf( newfname, "%s.bak", savefilename );

            remove( newfname );
            rename( savefilename, newfname );
            if ( writeSaveFile() == true )
            {
                printf( "done.\n" );
            }
            else
            {
                printf( "failed.\n" );

                rename( newfname, savefilename );
            }

        }
        else
        {
            printf( "Nothing do changed.\n" );
        }
    }
    else
    {
        printf( "Failed.\n" );
    }

    return 0;
}
